!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   abc :    The A --> B --> C reaction
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

  SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
! ---------- ---- 

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
  DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
  DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
  DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

  DOUBLE PRECISION u1, u2, u3, D, alpha, beta, B, sigma, E, u1C

   u1 = U(1)
   u2 = U(2)
   u3 = U(3)

   D = PAR(1)
   alpha = PAR(2)
   beta = PAR(3)
   B = PAR(4)
   sigma = PAR(5)

   E = EXP(u3)
   u1C = 1 - u1

   F(1) = -u1 + D*u1C*E
   F(2) = -u2 + D*E*(u1C - sigma*u2)
   F(3) = -u3 - beta*u3 + D*B*E*(u1C + alpha*sigma*u2)

  END SUBROUTINE FUNC

!---------------------------------------------------------------------- 

  SUBROUTINE STPNT(NDIM,U,PAR,T) 
! ---------- ----- 

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM
  DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
  DOUBLE PRECISION, INTENT(IN) :: T

  DOUBLE PRECISION D, alpha, beta, B, sigma

   D     = 0.
   alpha = 1.
   beta  = 1.0d0
   B     = 8.
   sigma = 0.04d0

   PAR(1) = D
   PAR(2) = alpha
   PAR(3) = beta
   PAR(4) = B
   PAR(5) = sigma

   U(1) = 0.
   U(2) = 0.
   U(3) = 0.

  END SUBROUTINE STPNT

!---------------------------------------------------------------------- 
  SUBROUTINE BCND 
  END SUBROUTINE BCND

  SUBROUTINE ICND 
  END SUBROUTINE ICND

  SUBROUTINE FOPT 
  END SUBROUTINE FOPT

  SUBROUTINE PVLS
  END SUBROUTINE PVLS
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
